require(['js/thirdparty/jquery/jquery-1.8.3.min.js'], 
		
	function()
	{
		window.game; //This is the main class of the project, and is set at the bottom of this file.
		window.debug = false;
		window.gameWidth = 944;
		window.gameHeight = 577;
		window.base_url = "";
		window.isMobile = !!(/Android|webOS|iPhone|iPad|iPod|BlackBerry|Kindle|Silk/i.test(navigator.userAgent) || (/Android|webOS|iPhone|iPad|iPod|BlackBerry|Kindle|Silk/i.test(navigator.platform)));
		window.siteParent = $('body');
		window.fps = 24;

		$(function()
		{
			$('head').append('<title>Milkshake Sorting Game</title>');
			/*
			window.siteParent.html('\
			    <div id="site_wrapper" style="position:absolute; left:0%; top:0%; width:100%; height:100%;">\
		        	<canvas id="game_canvas" width="944" height="577" style="position:absolute; left:0%; top:0%; width:100%; height:100%"></canvas>\
		        	<img id="no_support" src="images/no_support.jpg" style="width:100%; height:100%">\
		        	<img id="rotate" src="images/no_support.jpg" style="width:100%; height:100%">\
		        </div>'
			);*/
			window.siteParent.html('<div id="site_wrapper" style="position:absolute; width:100%; height:100%; overflow:hidden;">\
					<canvas id="game_canvas" width="944" height="577" style="position:absolute; left:0px; top:0px;"></canvas>\
				</div>');
			
			$("#no_support").hide();
			
			define("config", {
		         baseUrl: ""
		     });
		     
		    get_preloader_config();
		    
		    require([window.base_url + 'js/bionic/preloader.js'], function(Preloader){
				init_site(Preloader);
			});	
		
			resize_window();
		});
		
		$(window).resize( function(){
			resize_window();
		});
		
		function init_site(Preloader)
		{
	        resize_window();

	        
	        if (isCanvasSupported() == false)
	        {
		        $("#no_support").show();
		        $("#site_canvas").hide();
	        } else {
		        $("#no_support").hide();
		        $("#site_canvas").show();
	        
				window.preloader = new Preloader();
				
				require.config(get_require_config());
				require(['bionic/game'], function(Site){
					window.game = new Site();
					window.game.preload();
				});   
	        }
		}
		
		function get_preloader_config()
		{
			require.config({
			    baseUrl: window.base_url + "js/",
				waitSeconds: 200,
				paths: {
					"TweenMax": "thirdparty/gsap/tweenmax.min",
					"easeljs": "thirdparty/easeljs/easeljs-0.7.0.min",
					"preloadjs": "thirdparty/preloadjs/preloadjs-0.4.0.min",
				},
				deps: [
					"jquery",
				],
				urlArgs:"noCache=" + (function(){
					return (new Date()).getTime();
					}()),
				enforceDefine: true,
				shim:{
					"easeljs": {
						exports:'createjs'
					},
					"preloadjs": {
						deps: ['easeljs'],
						exports:'createjs'
					}
				}
		    }); 
		}
		
		function get_require_config()
		{
			require.config({
			    baseUrl: window.base_url + "js/",
				waitSeconds: 200,
				paths: {
					"TweenMax": "thirdparty/gsap/tweenmax.min",
					"easeljs": "thirdparty/easeljs/easeljs-0.7.0.min",
					"preloadjs": "thirdparty/preloadjs/preloadjs-0.4.0.min",
				},
				deps: [
					"jquery",
				],
				urlArgs:"noCache=" + (function(){
					if (window.debug){
					return (new Date()).getTime();
					}else{
					return "false";
					}
					}()),
				enforceDefine: true,
				shim:{
					"easeljs": {
						exports:'createjs'
					},
					"preloadjs": {
						deps: ['easeljs'],
						exports:'createjs'
					}
				}
		    }); 
		}
		
		function isCanvasSupported()
		{
			var canvas_compatible = false;
			try {
				canvas_compatible = !!(document.createElement('canvas').getContext('2d')); // S60
				} catch(e) {
				canvas_compatible = !!(document.createElement('canvas').getContext); // IE
			} 
			return canvas_compatible;
		}
		
		window.resize_window = function()
		{
			var nd = resize_to_fill_bounds(944, 577, $('#site_wrapper').width(), $('#site_wrapper').height());
			$('#game_canvas').width(nd.width);
			$('#game_canvas').height(nd.height);
			$('#game_canvas').css({
				width:nd.width + 'px',
				height:nd.height + 'px',
				left:((nd.width - $('#site_wrapper').width())/-2) + 'px',
				top:((nd.height - $('#site_wrapper').height())/-2) + 'px'  
			});
			
			if(window.game != null)
			{
				var _width = 944 * (1-(nd.width - $('#site_wrapper').width()) / nd.width);
				var _height = 577 * (1-(nd.height - $('#site_wrapper').height()) / nd.height);
				window.game.update_dimensions(_width, _height);
			}
		}
		
		function resize_to_fill_bounds(iw, ih, bw, bh)
		{
			var rw;
			var rh;
			var p;

			if(ih > iw)
			{
				rw = bw;
				p = rw / iw;
				rh = p * ih;

				if(rh < bh)
				{
					rh = bh;
					p = rh / ih;
					rw = p * iw;						
				}
			}
			else if(iw > ih)
			{
				rh = bh;
				p = rh / ih;
				rw = p * iw;

				if(rw < bw)
				{
					rw = bw;
					p = rw / iw;
					rh = p * ih;						
				}
			}

			return {width:rw, height:rh};
		}
		
		/*	
		function resize_window()
		{
			var wrapper = $("#site_wrapper");
			var width = wrapper.width();
			var height = wrapper.height();
			var max_width = window.gameWidth;
			var max_height = window.gameHeight;
			var ratio = max_height / max_width;
			var canvas = $('#game_canvas');
			var rotate = $("#rotate");
			
			if (width > height)
	        {
	            rotate.hide();
	            canvas.show();
	        } else
	        {
	            rotate.show();
	            canvas.hide();
	        }
				
			width = height * 1.61;
			
			wrapper.css('width', '100%');
			
			wrapper.css('max-width', max_width);
			wrapper.css('max-height', max_height);

		}*/
		
	}
);			