define([
         "util/classutils",
         "preloadjs",
         ],
         function(classUtils, preloadjs) {
	
	"use strict";
	
	return classUtils.create({
		parent:null,
		holder:null,
		
		help_btn:null,
		restart_btn:null,
		favourite_btn:null,
		show_btn:null,
		continue_btn:null,
		yes_btn:null,
		no_btn:null,
		
		pause_text:null,
		confirm_text:null,
		
		bottom_buttons:[],
		desktop_button_positions:[{x:402, y:440}, {x:555, y:440}],
		mobile_button_positions:[{x:402-85, y:440}, {x:555-85, y:440}, {x:708-85, y:440}],
						
		init: function(_parent)
		{
			var self = this;
			
			self.parent = _parent;
						
			self.holder = new createjs.Container();
			self.parent.addChild(self.holder);
			
			var background = window.game.sprites.get_bitmap("instructions_background");
			self.holder.addChild(background);
			
			var graphic, image_data;
			
			var lozenge = new createjs.Container();
			lozenge.x = window.gameWidth/2;
			lozenge.y = window.gameHeight/2;
			self.holder.addChild(lozenge);
			
				graphic = window.game.sprites.get_bitmap("default_assets","game_paused_lozenge");
				image_data = window.game.sprites.get_data("default_assets","game_paused_lozenge");
				graphic.x = 0 - (image_data.width/2);
				graphic.y = 0 - (image_data.height/2);
				lozenge.addChild(graphic);
			
			self.pause_text = new createjs.Container();
			self.pause_text.x = 470;
			self.pause_text.y = 130;
			self.holder.addChild(self.pause_text);
			
				graphic = window.game.sprites.get_bitmap("default_assets","text_game_paused");
				image_data = window.game.sprites.get_data("default_assets","text_game_paused");
				graphic.x = 0 - (image_data.width/2);
				graphic.y = 0 - (image_data.height/2);
				self.pause_text.addChild(graphic);

			self.continue_btn = new createjs.Container();
			self.continue_btn.x = window.gameWidth/2;
			self.continue_btn.y = 275;
			self.continue_btn.scaleX = self.continue_btn.scaleY = 0.9;
			self.holder.addChild(self.continue_btn);
			
				graphic = window.game.sprites.get_bitmap("default_assets","btn_play");
				image_data = window.game.sprites.get_data("default_assets","btn_play");
				graphic.x = 0 - (image_data.width/2);
				graphic.y = 0 - (image_data.height/2);
				self.continue_btn.addChild(graphic);
			
			self.help_btn = new createjs.Container();
			self.help_btn.x = 251;
			self.help_btn.y = 440;
			//self.holder.addChild(self.help_btn);
			self.bottom_buttons.push(self.help_btn);
			
				graphic = window.game.sprites.get_bitmap("default_assets","btn_pause_help");
				image_data = window.game.sprites.get_data("default_assets","btn_pause_help");
				graphic.x = 0 - (image_data.width/2);
				graphic.y = 0 - (image_data.height/2);
				self.help_btn.addChild(graphic);
			
			self.restart_btn = new createjs.Container();
			self.restart_btn.x = 402;
			self.restart_btn.y = 440;
			//self.holder.addChild(self.restart_btn);
			self.bottom_buttons.push(self.restart_btn);
			
				graphic = window.game.sprites.get_bitmap("default_assets","btn_pause_restart");
				image_data = window.game.sprites.get_data("default_assets","btn_pause_restart");
				graphic.x = 0 - (image_data.width/2);
				graphic.y = 0 - (image_data.height/2);
				self.restart_btn.addChild(graphic);
			
			/*
			self.favourite_btn = new createjs.Container();
			self.favourite_btn.x = 555;
			self.favourite_btn.y = 440;
			self.holder.addChild(self.favourite_btn);
			
				graphic = window.game.sprites.get_bitmap("default_assets","btn_pause_favourite");
				image_data = window.game.sprites.get_data("default_assets","btn_pause_favourite");
				graphic.x = 0 - (image_data.width/2);
				graphic.y = 0 - (image_data.height/2);
				self.favourite_btn.addChild(graphic);
			*/
			
			self.show_btn = new createjs.Container();
			self.show_btn.x = 708;
			self.show_btn.y = 440;
			//self.holder.addChild(self.show_btn);
			self.bottom_buttons.push(self.show_btn);
			
				graphic = window.game.sprites.get_bitmap("close_but");
				image_data = window.game.sprites.get_data("close_but");
				graphic.x = 0 - (image_data.width/2);
				graphic.y = 0 - (image_data.height/2);
				self.show_btn.addChild(graphic);
			
			self.confirm_text = new createjs.Container();
			self.confirm_text.x = window.gameWidth/2;
			self.confirm_text.y = 150;
			self.holder.addChild(self.confirm_text);
			
				graphic = window.game.sprites.get_bitmap("default_assets","text_are_you_sure");
				image_data = window.game.sprites.get_data("default_assets","text_are_you_sure");
				graphic.x = 0 - (image_data.width/2);
				graphic.y = 0 - (image_data.height/2);
				self.confirm_text.addChild(graphic);
			
			self.yes_btn = new createjs.Container();
			self.yes_btn.x = 364;
			self.yes_btn.y = 360;
			self.holder.addChild(self.yes_btn);
			
				graphic = window.game.sprites.get_bitmap("default_assets","btn_yes");
				image_data = window.game.sprites.get_data("default_assets","btn_yes");
				graphic.x = 0 - (image_data.width/2);
				graphic.y = 0 - (image_data.height/2);
				self.yes_btn.addChild(graphic);
			
			self.no_btn = new createjs.Container();
			self.no_btn.x = 580;
			self.no_btn.y = 360;
			self.holder.addChild(self.no_btn);
			
				graphic = window.game.sprites.get_bitmap("default_assets","btn_no");
				image_data = window.game.sprites.get_data("default_assets","btn_no");
				graphic.x = 0 - (image_data.width/2);
				graphic.y = 0 - (image_data.height/2);
				self.no_btn.addChild(graphic);
			
			self.holder.visible = false;
			
			
			if(!window.isMobile)
			{
				self.bottom_buttons.pop();
			}
			
			for(var i = 0; i < self.bottom_buttons.length; i++)
			{
				if(window.isMobile)
				{
					self.bottom_buttons[i].x = self.mobile_button_positions[i].x;
					self.bottom_buttons[i].y = self.mobile_button_positions[i].y;
				}
				else
				{
					self.bottom_buttons[i].x = self.desktop_button_positions[i].x;
					self.bottom_buttons[i].y = self.desktop_button_positions[i].y;
				}
				self.holder.addChild(self.bottom_buttons[i]);
			}
		},
		
		show : function ()
		{
			var self = this;	
			self.holder.visible = true;
			
			self.build_page();
		},
		
		hide : function ()
		{
			var self = this;
			
			self.remove_clicks(1);
			self.remove_clicks(2);
			
			self.holder.visible = false;
		},
		
		build_page: function()
		{
			var self = this;
			
			self.hide_confirm_section();
			self.show_pause_section();
		},
		
		add_clicks : function(stage)
		{
			var self = this;
			var image_data, rect;
			
			if (stage == 1)
			{
				image_data = window.game.sprites.get_data("default_assets","btn_play");
				rect = {x:self.continue_btn.x - (image_data.width/2), y:self.continue_btn.y - (image_data.height/2), w:image_data.width, h:image_data.height};
				window.game.mouse.add_click('pause_play_click', rect, function(){
					self.hide();
					window.game.game.unpause_game();
				});
				
				image_data = window.game.sprites.get_data("default_assets","btn_pause_help");
				rect = {x:self.help_btn.x - (image_data.width/2), y:self.help_btn.y - (image_data.height/2), w:image_data.width, h:image_data.height};
				window.game.mouse.add_click('pause_help_click', rect, function(){
					self.remove_clicks(1);
					window.game.game_instructions_show();
				});	
				
				image_data = window.game.sprites.get_data("default_assets","btn_pause_restart");
				rect = {x:self.restart_btn.x - (image_data.width/2), y:self.restart_btn.y - (image_data.height/2), w:image_data.width, h:image_data.height};
				window.game.mouse.add_click('pause_restart_click', rect, function(){
					//hide pause and show confirm
					self.hide_pause_section();
					self.show_confirm_section();
				});		
				
				/*
				image_data = window.game.sprites.get_data("default_assets","btn_pause_favourite");
				rect = {x:self.favourite_btn.x - (image_data.width/2), y:self.favourite_btn.y - (image_data.height/2), w:image_data.width, h:image_data.height};
				window.game.mouse.add_click('pause_favourite_click', rect, function(){
					//show btn code to go in here.
				});*/	
				
				image_data = window.game.sprites.get_data("default_assets","btn_pause_show");
				rect = {x:self.show_btn.x - (image_data.width/2), y:self.show_btn.y - (image_data.height/2), w:image_data.width, h:image_data.height};
				window.game.mouse.add_click('pause_show_click', rect, function(){
					
					if(window.isMobile)
					{
						var iframe = document.createElement("IFRAME");
						iframe.setAttribute("src", "js-frame:backtoIOSApp");
						document.documentElement.appendChild(iframe);
						iframe.parentNode.removeChild(iframe);
						iframe = null;
						console.log("quit button pressed");
					}
				});		
			} else {
				image_data = window.game.sprites.get_data("default_assets","btn_yes");
				rect = {x:self.yes_btn.x - (image_data.width/2), y:self.yes_btn.y - (image_data.height/2), w:image_data.width, h:image_data.height};
				window.game.mouse.add_click('confirm_yes_click', rect, function(){
					self.hide();
					window.game.game.restart_game();
				});	
				
				image_data = window.game.sprites.get_data("default_assets","btn_no");
				rect = {x:self.no_btn.x - (image_data.width/2), y:self.no_btn.y - (image_data.height/2), w:image_data.width, h:image_data.height};
				window.game.mouse.add_click('confirm_no_click', rect, function(){
					self.hide_confirm_section();
					self.show_pause_section();
				});	
			}
		},
		
		remove_clicks : function(stage)
		{
			if (stage == 1)
			{
				window.game.mouse.remove_click("pause_play_click");
				window.game.mouse.remove_click("pause_help_click");
				window.game.mouse.remove_click("pause_restart_click");
				window.game.mouse.remove_click("pause_favourite_click");
				window.game.mouse.remove_click("pause_show_click");	
			} else {
				window.game.mouse.remove_click("confirm_yes_click");	
				window.game.mouse.remove_click("confirm_no_click");	
			}
		},
		
		show_pause_section : function()
		{
			var self = this;
			
			self.continue_btn.visible = true;	
			self.help_btn.visible = true;	
			self.restart_btn.visible = true;	
			self.show_btn.visible = true;	
			//self.favourite_btn.visible = true;
			
			self.pause_text.visible = true;	
			
			self.add_clicks(1);
		},
		
		hide_pause_section : function()
		{
			var self = this;	
			
			self.continue_btn.visible = false;	
			self.help_btn.visible = false;	
			self.restart_btn.visible = false;	
			self.show_btn.visible = false;	
			//self.favourite_btn.visible = false;
			
			self.pause_text.visible = false;	
			
			self.remove_clicks(1);
		},
		
		show_confirm_section : function()
		{
			var self = this;	
			
			self.confirm_text.visible = true;
			self.yes_btn.visible = true;
			self.no_btn.visible = true;
			
			self.add_clicks(2);
		},
		
		hide_confirm_section : function()
		{
			var self = this;
			
			self.confirm_text.visible = false;
			self.yes_btn.visible = false;
			self.no_btn.visible = false;	
			
			self.remove_clicks(2);
		},
		
		update : function ()
		{
			var self = this;
			self.canvas.update();
		}
	});
	
});