define([
         "util/classutils",
         "preloadjs",
         "bionic/sprites"
         ],
         function(classUtils, preloadjs, SpriteManager) {
	
	"use strict";
	
	return classUtils.create({
		canvas:null,
		sprites:null,
		assets:null,
		main_queue:null,
		holder:null,
		
		logo:null,
		character_left:null,
		character_right:null,
		character_left_positions:null,
		character_right_positions:null,
		title:null,
		
		loading_bar:null,
		candy_cane:null,
		mask:null,
		
		play_btn:null,
		
		init: function()
		{
			var self = this;
						
			self.canvas = new createjs.Stage("game_canvas");
			self.sprites = new SpriteManager();
			
			/*____CMS Edits____*/
	
			$.ajax({
				type: "GET",
			    url: "data.xml" + (window.debug ? "?noCache=" + new Date().getTime() : ""),
			    dataType: "xml",
			    success: function(result)
			    {
			    	var xml = $(result);
					xml.children('game').children('items').children('item').each(function(){
						
						if($(this).find("type").text() == "image")
						{
							var id = $(this).find("id").text();
							if(self.sprites.sheets[id] != null && 
								$(this).find("content").find("image").text() != undefined && 
								$(this).find("content").find("image").text() != null && 
								$(this).find("content").find("image").text() != "")
							{
								self.sprites.sheets[id].sheet = window.base_url + $(this).find("content").find("image").text();
								self.sprites.sheets[id].width = window.base_url + $(this).find("content").find("width").text();
								self.sprites.sheets[id].height = window.base_url + $(this).find("content").find("height").text();
							}
						}
					});
					self.create();
			    }
			});
			
			/*____CMS Edits____*/
		},
		
		create : function()
		{
			var self = this;
			
			self.holder = new createjs.Container();
			self.canvas.addChild(self.holder);

			var background = self.sprites.get_bitmap("preloader_background");
			self.holder.addChild(background);

			var graphic, image_data;

			self.logo = new createjs.Container();
			self.logo.x = 466;
			self.logo.y = 108;
			self.holder.addChild(self.logo);

			graphic = self.sprites.get_bitmap("preloader_logo");
			image_data = self.sprites.get_data("preloader_logo");
			graphic.x = 0 - (image_data.width/2);
			graphic.y = 0 - (image_data.height/2);
			self.logo.addChild(graphic);
			
			/*
			self.character_left = new createjs.Container();
			self.character_left.x = 125;
			self.character_left.y = 437;
			self.holder.addChild(self.character_left);

			graphic = self.sprites.get_bitmap("character_left");
			image_data = self.sprites.get_data("character_left");
			graphic.x = 0 - (image_data.width/2);
			graphic.y = 0 - (image_data.height/2);
			self.character_left.addChild(graphic);

			self.character_right = new createjs.Container();
			self.character_right.x = 819;
			self.character_right.y = 437;
			self.holder.addChild(self.character_right);
			*/
			
			self.character_left = new createjs.Container();
			self.holder.addChild(self.character_left);
			
			graphic = self.sprites.get_bitmap("character_left");
			image_data = self.sprites.get_data("character_left");
			graphic.x = -Math.round(image_data.width/2);
			graphic.y = -Math.round(image_data.height/2);
			self.character_left.addChild(graphic);
			
			self.character_left_positions = {
												start:{x:-(image_data.width/2), y:window.gameHeight - (image_data.height/2)}, 
												end:{x:(image_data.width/2), y:window.gameHeight - (image_data.height/2)}
											};
			
			self.character_right = new createjs.Container();
			self.character_right.x = 819;
			self.character_right.y = 437;
			self.holder.addChild(self.character_right);
			
			graphic = self.sprites.get_bitmap("character_right");
			image_data = self.sprites.get_data("character_right");
			graphic.x = 0 - (image_data.width/2);
			graphic.y = 0 - (image_data.height/2);
			self.character_right.addChild(graphic);
			
			self.character_right_positions = {
												start:{x:window.gameWidth+(image_data.width/2), y:window.gameHeight - (image_data.height/2)}, 
												end:{x:window.gameWidth-(image_data.width/2), y:window.gameHeight - (image_data.height/2)}
											};
			
			graphic = self.sprites.get_bitmap("character_right");
			image_data = self.sprites.get_data("character_right");
			graphic.x = 0 - (image_data.width/2);
			graphic.y = 0 - (image_data.height/2);
			self.character_right.addChild(graphic);

			self.title = new createjs.Container();
			self.title.x = 470;
			self.title.y = 310;
			self.holder.addChild(self.title);

			graphic = self.sprites.get_bitmap("preloader_title");
			image_data = self.sprites.get_data("preloader_title");
			graphic.x = 0 - (image_data.width/2);
			graphic.y = 0 - (image_data.height/2);
			self.title.addChild(graphic);

			self.loading_bar = new createjs.Container();
			self.loading_bar.x = 465;
			self.loading_bar.y = 435;
			self.holder.addChild(self.loading_bar);

			var ground = self.sprites.get_bitmap("default_assets", "preloader_ground");
			image_data = self.sprites.get_data("default_assets", "preloader_ground");
			ground.x = 0 - (image_data.width/2);
			ground.y = 0 - (image_data.height/2);
			self.loading_bar.addChild(ground);

			self.candy_cane = self.sprites.get_bitmap("default_assets", "preloader_candy");
			image_data = self.sprites.get_data("default_assets", "preloader_candy");
			self.candy_cane.x = 0 - (image_data.width/2);
			self.candy_cane.y = 0 - (image_data.height/2);
			self.loading_bar.addChild(self.candy_cane);

			var outline = self.sprites.get_bitmap("default_assets", "preloader_outline");
			image_data = self.sprites.get_data("default_assets", "preloader_outline");
			outline.x = 0 - (image_data.width/2);
			outline.y = 0 - (image_data.height/2);
			self.loading_bar.addChild(outline);

			image_data = self.sprites.get_data("default_assets", "preloader_ground");

			self.mask = new createjs.Shape();
			self.mask.graphics.beginFill('#00000');
			self.mask.graphics.drawRoundRect(0, 0 - (image_data.height/2), image_data.width, image_data.height, 50);
			self.mask.graphics.endFill();
			self.mask.x = 0 - (image_data.width/2);
			self.mask.scaleX = 0;
			self.candy_cane.mask = self.mask;

			var overlay = self.sprites.get_bitmap("default_assets", "preloader_overlay");
			image_data = self.sprites.get_data("default_assets", "preloader_overlay");
			overlay.x = 0 - (image_data.width/2);
			overlay.y = 0 - (image_data.height/2);
			self.loading_bar.addChild(overlay);

			self.play_btn = new createjs.Container();
			self.play_btn.x = 472;
			self.play_btn.y = 460;
			self.holder.addChild(self.play_btn);

			graphic = self.sprites.get_bitmap("default_assets", "btn_play");
			image_data = self.sprites.get_data("default_assets", "btn_play");
			graphic.x = 0 - (image_data.width/2);
			graphic.y = 0 - (image_data.height/2);
			self.play_btn.addChild(graphic);
		},
		
		show : function ()
		{
			var self = this;	
			
			TweenMax.to(self.holder, 0.5, {alpha:1});
			
			self.build_preloader();
		},
		
		show_title : function()
		{
			var self = this;
			
			self.holder.visible = true;
			TweenMax.to(self.holder, 0.5, {alpha:1});
			
			self.build_title();
		},
		
		hide : function ()
		{
			var self = this;
			
			TweenMax.to(self.holder, 0.5, {delay:0.65, alpha:0});
		},
		
		build_preloader: function()
		{
			var self = this;
			
			self.logo.scaleX = self.logo.scaleY = self.title.scaleX = self.title.scaleY = 0;
			
			self.loading_bar.scaleY = self.play_btn.scaleY = 0;
			
			/*
			var start_positions = [{x:-150, y:437}, {x:1100, y:437}];
			var end_positions = [{x:125, y:437}, {x:819, y:437}];
			
			self.character_left.x = start_positions[0].x;
			self.character_left.y = start_positions[0].y;
			self.character_right.x = start_positions[1].x;
			self.character_right.y = start_positions[1].y;
			
			TweenMax.to(self.character_left, 0.15, {delay:0.25, ease:Linear.easeOut, x:end_positions[0].x, y:end_positions[0].y});
			TweenMax.to(self.character_right, 0.15, {delay:0.25, ease:Linear.easeOut, x:end_positions[1].x, y:end_positions[1].y});
			*/
			
			self.character_left.x = self.character_left_positions.start.x;
			self.character_left.y = self.character_left_positions.start.y;
			
			self.character_right.x = self.character_right_positions.start.x;
			self.character_right.y = self.character_right_positions.start.y;
			
			TweenMax.to(self.character_left, 0.15, {delay:0.25, ease:Linear.easeOut, x:self.character_left_positions.end.x, y:self.character_left_positions.end.y});
			TweenMax.to(self.character_right, 0.15, {delay:0.25, ease:Linear.easeOut, x:self.character_right_positions.end.x, y:self.character_right_positions.end.y});
			
			TweenMax.to(self.logo, 0.25, {delay:0.4, scaleX:1, scaleY:1, ease:Back.easeOut});
			TweenMax.to(self.title, 0.25, {delay:0.65, scaleX:1, scaleY:1, ease:Back.easeOut});
			
			TweenMax.to(self.loading_bar, 0.15, {delay:1, scaleY:1, ease:Back.easeOut});
		},
		
		build_title: function()
		{
			var self = this;
			
			self.logo.scaleX = self.logo.scaleY = self.title.scaleX = self.title.scaleY = 0;
			
			self.loading_bar.scaleY = self.play_btn.scaleY = 0;
			
			/*
			var start_positions = [{x:-150, y:437}, {x:1100, y:437}];
			var end_positions = [{x:125, y:437}, {x:819, y:437}];
			
			self.character_left.x = start_positions[0].x;
			self.character_left.y = start_positions[0].y;
			self.character_right.x = start_positions[1].x;
			self.character_right.y = start_positions[1].y;
			
			TweenMax.to(self.character_left, 0.15, {delay:0.25, ease:Linear.easeOut, x:end_positions[0].x, y:end_positions[0].y});
			TweenMax.to(self.character_right, 0.15, {delay:0.25, ease:Linear.easeOut, x:end_positions[1].x, y:end_positions[1].y});
			*/
			
			self.character_left.x = self.character_left_positions.start.x;
			self.character_left.y = self.character_left_positions.start.y;
			
			self.character_right.x = self.character_right_positions.start.x;
			self.character_right.y = self.character_right_positions.start.y;
			
			TweenMax.to(self.character_left, 0.15, {delay:0.25, ease:Linear.easeOut, x:self.character_left_positions.end.x, y:self.character_left_positions.end.y});
			TweenMax.to(self.character_right, 0.15, {delay:0.25, ease:Linear.easeOut, x:self.character_right_positions.end.x, y:self.character_right_positions.end.y});
			
			TweenMax.to(self.logo, 0.25, {delay:0.4, scaleX:1, scaleY:1, ease:Back.easeOut});
			TweenMax.to(self.title, 0.25, {delay:0.65, scaleX:1, scaleY:1, ease:Back.easeOut});
			
			TweenMax.to(self.play_btn, 0.25, {delay:0.45, scaleY:1, ease:Back.easeOut, onComplete:function(){
				self.add_clicks();
			}});
		},
		
		add_clicks:function()
		{
			var self = this;
			var image_data = self.sprites.get_data("default_assets", "btn_play");
			
			var rect = {x:self.play_btn.x - (image_data.width/2), y:self.play_btn.y - (image_data.height/2), w:image_data.width, h:image_data.height};
			window.game.mouse.add_click('preloader_play_btn_click', rect, function(){
				window.game.mouse.remove_click("preloader_play_btn_click");
				TweenMax.to(self.play_btn, 0.35, {overwrite:true, scaleY:0, ease:Back.easeIn, onComplete:function(){
					window.game.startGame();
				}});	
				window.game.sound_managers.general.play("click");
				window.game.sound_managers.bgm.play("title");
			}, null);	
		},
		
		preload:function(_assets)
		{
			var self = this;
			self.assets = _assets;
			
			self.main_queue = new createjs.LoadQueue(false);
			
			self.main_queue.installPlugin(createjs.Sound);
			
			self.main_queue.addEventListener("fileload", function(event){
				self.queue_load_progress(event);	
			});
			self.main_queue.addEventListener("complete", function(){
				self.queue_load_complete();
			});
			self.main_queue.addEventListener("error", function(event){
				self.queue_load_error(event);
			});
			
			var i;
			for (i=0; i < self.assets.length; i++)
			{
				self.main_queue.loadFile(self.assets[i]);
			}

			self.main_queue.load();
		},
		
		update : function ()
		{
			var self = this;
			self.canvas.update();
		},

		queue_load_progress : function(e)
		{
			var self = this;
			var progress = self.main_queue.progress.toFixed(2);
			var percentage = progress;
			
			self.mask.scaleX = percentage;
		},
		
		queue_load_error : function(e)
		{
			
		},
		
		queue_load_complete : function()
		{
			var self = this;
			
			self.mask.scaleX = 1;
			
			TweenMax.to(self.loading_bar, 0.35, {scaleY:0, ease:Back.easeIn});	
			
			setTimeout(function(){self.loading_bar.visible = false;}, 450);
			
			TweenMax.to(self.play_btn, 0.25, {delay:0.45, scaleY:1, ease:Back.easeOut, onComplete:function(){
				self.add_clicks();
			}});
			
			window.game.sound_managers.general.play("loading", 200);
		}
			
	});
	
});