define([
         "util/classutils",
         ],
         function(classUtils) {
	
	"use strict";
	
	return classUtils.create({

		items:null,
		
		init: function()
		{
			var self = this;
			self.items = [];
		},
		
		add_item: function(_item, _rect, _x_side, _y_side)
		{
			//x_side and y_side is either 1 (left/top) or -1 (right/bottom)
			
			var self = this;

			var item = {item:_item, rect:_rect, item_defaults:{x:_item.x, y:_item.y}, rect_defaults:_rect != null ? {x:_rect.x, y:_rect.y} : null, x_side:_x_side, y_side:_y_side};
			self.items.push(item);
			window.resize_window();
		},
		
		update: function(x_margin, y_margin)
		{
			var self = this;
			for(var i in self.items)
			{
				self.items[i].item.x = self.items[i].item_defaults.x + (x_margin * self.items[i].x_side);
				self.items[i].item.y = self.items[i].item_defaults.y + (y_margin * self.items[i].y_side);
				
				if(self.items[i].rect != null)
				{
					self.items[i].rect.x = self.items[i].rect_defaults.x + (x_margin * self.items[i].x_side);
					self.items[i].rect.y = self.items[i].rect_defaults.y + (y_margin * self.items[i].y_side);
				}
			}
		}

	});
	
});