﻿define([
         "util/classutils",
         ],
         function(classUtils) {
	
	"use strict";
	
	return classUtils.create({
		
		sheets:null,
		
		init:function()
		{
			var self = this;
			
			self.sheets = {
				/* Non-Page-Specific assets */
				character_left:{
					sheet:window.base_url + 'images/character_left.png',
					width:250,
					height:350	
				},
				character_right:{
					sheet:window.base_url + 'images/character_right.png',
					width:250,
					height:350	
				},
				/* Preloader Assets */
				preloader_background:{
					sheet:window.base_url + 'images/preloader/background.jpg',
					width:944,
					height:577	
				},
				preloader_logo:{
					sheet:window.base_url + 'images/preloader/logo.png',
					width:300,
					height:200
				},
				preloader_title:{
					sheet:window.base_url + 'images/preloader/title.png',
					width:500,
					height:150
				},
				/* Non Editable Assets  */
				default_assets:{
					sheet:window.base_url + 'images/game0.png',
					sprites:{
						btn_back:[1888, 599, 74, 74, false],
						btn_close:[1624, 815, 76, 80, false],
						btn_no:[1208, 527, 189, 199, false],
						btn_pause_favourite:[1373, 731, 132, 139, false],
						btn_pause_help:[1582, 671, 132, 139, false],
						btn_pause_restart:[1582, 527, 132, 139, false],
						btn_pause_show:[1068, 491, 135, 146, false],
						btn_play:[1723, 344, 189, 199, false],
						btn_yes:[1734, 140, 189, 199, false],
						bucket:[1025, 642, 110, 119, false],
						bucket_inside:[1510, 815, 109, 56, false],
						clock_overlay:[1200, 731, 168, 160, false],
						clock_spark:[1140, 642, 62, 58, false],
						cursor:[1510, 719, 58, 91, false],
						game_paused_lozenge:[5, 5, 714, 464, false],
						hand:[1884, 713, 106, 116, false],
						instructions_arrow:[1402, 527, 175, 187, false],
						instructions_happy:[1719, 713, 160, 160, false],
						instructions_sad:[1719, 548, 164, 160, false],
						preloader_candy:[588, 491, 475, 64, false],
						preloader_ground:[1218, 458, 475, 64, false],
						preloader_outline:[724, 408, 489, 78, false],
						preloader_overlay:[1233, 389, 475, 64, false],
						text_are_you_sure:[5, 733, 482, 113, false],
						text_game_complete:[588, 560, 468, 71, false],
						text_game_over:[724, 315, 504, 88, false],
						text_game_paused:[5, 474, 578, 99, false],
						text_level_1:[1229, 5, 500, 150, false],
						text_level_1_complete:[964, 771, 231, 130, false],
						text_level_2:[724, 160, 500, 150, false],
						text_level_2_complete:[728, 771, 231, 130, false],
						text_level_3:[5, 578, 500, 150, false],
						text_level_3_complete:[492, 746, 231, 130, false],
						text_level_4:[724, 5, 500, 150, false],
						text_level_4_complete:[789, 636, 231, 130, false],
						text_level_5:[1229, 160, 457, 129, false],
						text_level_5_complete:[1734, 5, 231, 130, false],
						text_play_again:[510, 636, 274, 105, false],
						text_well_done:[1233, 294, 485, 90, false],
						timer_hand:[510, 578, 14, 52, false],
						ui_pause:[1917, 514, 76, 80, false],
						ui_sound_off:[1917, 429, 76, 80, false],
						ui_sound_on:[1917, 344, 76, 80, false]
					}
				},
				/* Instructions */
				instructions_background:{
					sheet:window.base_url + 'images/instructions/background.jpg',
					width:944,
					height:577
				},
				instructions_bucket:{
					sheet:window.base_url + 'images/instructions/bucket.png',
					width:351,
					height:194	
				},
				instructions_lozenge:{
					sheet:window.base_url + 'images/instructions/lozenge.png',
					width:714,
					height:464
				},
				instructions_trumpet:{
					sheet:window.base_url + 'images/instructions/trumpet.png',
					width:183,
					height:113
				},
				/* Game */
				game_background:{
					sheet:window.base_url + 'images/game_background.jpg',
					width:944,
					height:577	
				},
				game_object_1:{
					sheet:window.base_url + 'images/game_objects/object_1.png',
					width:120,
					height:120
				},
				game_object_2:{
					sheet:window.base_url + 'images/game_objects/object_2.png',
					width:120,
					height:120
				},
				game_object_3:{
					sheet:window.base_url + 'images/game_objects/object_3.png',
					width:120,
					height:120
				},
				game_object_4:{
					sheet:window.base_url + 'images/game_objects/object_4.png',
					width:120,
					height:120
				},
				ingame_character:{
					sheet:window.base_url + 'images/ingame_character.png',
					width:150,
					height:250	
				},
				close_but:{
					sheet:window.base_url + 'images/close_but.png',
					width:132,
					height:139
				},
				text_level_1:{
					sheet:window.base_url + 'images/level1.png',
					width:402,
					height:142
				},
				text_level_2:{
					sheet:window.base_url + 'images/level2.png',
					width:437,
					height:142
				},
				text_level_3:{
					sheet:window.base_url + 'images/level3.png',
					width:438,
					height:142
				},
				text_level_4:{
					sheet:window.base_url + 'images/level4.png',
					width:441,
					height:142
				},
				text_level_5:{
					sheet:window.base_url + 'images/level5.png',
					width:435,
					height:142
				}
			};
		},
		
		get_bitmap:function(sheet, sprite)
		{
			var self = this;
			return self.get_bitmap_from_data(self.get_data(sheet, sprite));
		},
		
		get_object_bitmap:function(sprite)
		{
			var self = this;
			var object_sheets = ['objects_0'];
			
			for(var i in object_sheets)
			{
				for(var j in self.sheets[object_sheets[i]].sprites)
				{
					if(j === sprite)
						return self.get_bitmap(object_sheets[i], j);
				}	
			}
		},
		
		get_data:function(sheet, sprite)
		{
			var self = this;
			
			if(self.sheets[sheet])
			{
				var obj;
				
				var res_scale = 1;
				
				if(self.sheets[sheet]['sheet_' + window.ada_res])
				{
					res_scale = window.ada_image_scale;
				}
				
				if(sprite == null)
				{
					obj = { 
							x:0,
							y:0,
							true_width:self.sheets[sheet].width,
							true_height:self.sheets[sheet].height,
							rotation:false
						};
				}	
				else if(self.sheets[sheet].sprites[sprite])
				{
					obj = { 
							x:self.sheets[sheet].sprites[sprite][0] * res_scale,
							y:self.sheets[sheet].sprites[sprite][1] * res_scale,
							true_width:self.sheets[sheet].sprites[sprite][2],
							true_height:self.sheets[sheet].sprites[sprite][3]
						};
					
					if(self.sheets[sheet].sprites[sprite][4])
					{
						obj.rotation = true;
					}
					else
					{
						obj.rotation = false;
					}	
				}
				
				if(obj)
				{
					if(obj.rotation == true)
					{
						var w = obj.true_width;
						var h = obj.true_height;
						obj.true_width = h;
						obj.true_height = w;
					}
					
					obj.width = obj.true_width * res_scale;
					obj.height = obj.true_height * res_scale;
					
					if(self.sheets[sheet]['sheet_' + window.ada_res])
					{
						obj.sheet = self.sheets[sheet]['sheet_' + window.ada_res];
					}
					else if(self.sheets[sheet].sheet)
					{
						obj.sheet = self.sheets[sheet].sheet;
					}
					else
					{
						console.log("Image file could not be found for sheet:'" + sheet + "' - ensure 'sheet' or 'sheet_" + window.ada_res + "' is specified");
						obj = null;
					}
				}	
				
				return obj;
			}
			
			console.log("Requested sprite (sheet:" + sheet + ", sprite:" + sprite + " not found)");
			return null;
		},
				
		get_bitmap_from_data:function(data)
		{
			var self = this;
			
			if(data)
			{
				var image = new Image();
				if (!window.ada_is_mobile)
				{
					image.crossOrigin = 'Anonymous';	
				}
				image.src = data.sheet;
			
				var bmp = new createjs.Bitmap(image);
				
				var spr = new createjs.Container();
				
				if(data.rotation)
				{	
					bmp.sourceRect = new createjs.Rectangle(data.x, data.y, data.height, data.width);
					bmp.rotation = -90;
					bmp.y = data.true_height;
					if (data.true_height != data.height)
					{
						bmp.scaleX = data.true_height / data.height;	
					}
					
					if (data.true_width != data.width)
					{
						bmp.scaleY = data.true_width / data.width;	
					}
				}
				else
				{
					bmp.sourceRect = new createjs.Rectangle(data.x, data.y, data.width, data.height);
					if (data.true_height != data.height)
					{
						bmp.scaleX = data.true_width / data.width;
					}
					
					if (data.true_width != data.width)
					{
						bmp.scaleY = data.true_height / data.height;
					}
				}
					
				spr.addChild(bmp);
				
				return spr;
			}
			
			return null;
		}
		
	});

});